void disassemble_i386_insn (interpreter_t *intp) {
word_8 opcode, opcode2;
word_32 pc, next_pc;
int prefix_flags;
word_8 mod, reg, rm, sib_scale, sib_index, sib_base, disp8, opcode_reg, imm8;
word_16 imm16;
word_32 disp32, imm32;
i386_decode_opcode(intp, &prefix_flags, &opcode, &opcode2);
switch (opcode) {
case 51 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 50 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 49 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 48 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 53 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 52 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 135 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("xchg ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("xchg ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 134 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("xchg ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 144 :
case 145 :
case 146 :
case 147 :
case 148 :
case 149 :
case 150 :
case 151 :
opcode_reg = opcode - 144;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("xchg ", stdout);
i386_disassemble_r16(stdout, opcode_reg);
fputs(",", stdout);
fputs("ax", stdout);
} else {
next_pc = pc = intp->pc;
fputs("xchg ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
fputs(",", stdout);
fputs("eax", stdout);
}
break;
case 133 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 132 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 169 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 168 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 43 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 42 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 41 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 40 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 45 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 44 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 171 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("stosw ", stdout);
fputs("ax", stdout);
} else {
next_pc = pc = intp->pc;
fputs("stosd ", stdout);
fputs("eax", stdout);
}
break;
case 170 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("stosb ", stdout);
fputs("al", stdout);
}
break;
case 27 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 26 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 25 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 24 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 29 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 28 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 209 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
} else {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
} else {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
} else {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
default :
bt_assert(0);
}
}
break;
case 192 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
default :
bt_assert(0);
}
}
break;
case 210 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
default :
bt_assert(0);
}
}
break;
case 208 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("1", stdout);
}
break;
default :
bt_assert(0);
}
}
break;
case 193 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("ror ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("ror ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
default :
bt_assert(0);
}
}
break;
case 211 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
} else {
next_pc = pc = intp->pc;
fputs("shr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
} else {
next_pc = pc = intp->pc;
fputs("shl ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
} else {
next_pc = pc = intp->pc;
fputs("sar ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("rol ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
} else {
next_pc = pc = intp->pc;
fputs("rol ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
fputs("cl", stdout);
}
break;
default :
bt_assert(0);
}
}
break;
case 194 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("ret ", stdout);
printf("$0x%x", imm16);
}
break;
case 195 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("ret", stdout);
}
break;
case 242 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 174 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("repne_scasb", stdout);
}
break;
default :
switch (reg) {
default :
bt_assert(0);
}
}
break;
case 243 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 171 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("rep_stosd", stdout);
}
break;
case 170 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("rep_stosb", stdout);
}
break;
case 165 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("rep_movsd", stdout);
}
break;
case 164 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("rep_movsb", stdout);
}
break;
case 166 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("repe_cmpsb", stdout);
}
break;
default :
switch (reg) {
default :
bt_assert(0);
}
}
break;
case 104 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("push ", stdout);
printf("$0x%x", imm32);
}
break;
case 106 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("push ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 80 :
case 81 :
case 82 :
case 83 :
case 84 :
case 85 :
case 86 :
case 87 :
opcode_reg = opcode - 80;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("push ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
}
break;
case 88 :
case 89 :
case 90 :
case 91 :
case 92 :
case 93 :
case 94 :
case 95 :
opcode_reg = opcode - 88;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("pop ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
}
break;
case 143 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("pop ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 11 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 10 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 9 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 8 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 13 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 12 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 199 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
default :
bt_assert(0);
}
}
break;
case 198 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
default :
bt_assert(0);
}
}
break;
case 184 :
case 185 :
case 186 :
case 187 :
case 188 :
case 189 :
case 190 :
case 191 :
opcode_reg = opcode - 184;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r16(stdout, opcode_reg);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 176 :
case 177 :
case 178 :
case 179 :
case 180 :
case 181 :
case 182 :
case 183 :
opcode_reg = opcode - 176;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r8(stdout, opcode_reg);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 163 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
printf("0x%x", imm32);
fputs(",", stdout);
fputs("ax", stdout);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
printf("0x%x", imm32);
fputs(",", stdout);
fputs("eax", stdout);
}
break;
case 161 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("0x%x", imm32);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("mov ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("0x%x", imm32);
}
break;
case 139 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 138 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 137 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 136 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("mov ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 141 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("lea ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 120 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("js ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 122 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jp ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 121 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jns ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 123 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jnp ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 117 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jne ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 233 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jmp ", stdout);
printf("$0x%x", imm32);
}
break;
case 235 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jmp ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 126 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jle ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 124 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jl ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 125 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jge ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 127 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jg ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 116 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("je ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 118 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jbe ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 114 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jb ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 115 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("jae ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 119 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("ja ", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 205 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("int ", stdout);
printf("$0x%x", imm8);
}
break;
case 64 :
case 65 :
case 66 :
case 67 :
case 68 :
case 69 :
case 70 :
case 71 :
opcode_reg = opcode - 64;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("inc ", stdout);
i386_disassemble_r16(stdout, opcode_reg);
} else {
next_pc = pc = intp->pc;
fputs("inc ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
}
break;
case 105 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 221 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 232 :
case 233 :
case 234 :
case 235 :
case 236 :
case 237 :
case 238 :
case 239 :
opcode_reg = opcode2 - 232;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fucomp ", stdout);
printf("%d", opcode_reg);
}
break;
case 224 :
case 225 :
case 226 :
case 227 :
case 228 :
case 229 :
case 230 :
case 231 :
opcode_reg = opcode2 - 224;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fucom ", stdout);
printf("%d", opcode_reg);
}
break;
case 216 :
case 217 :
case 218 :
case 219 :
case 220 :
case 221 :
case 222 :
case 223 :
opcode_reg = opcode2 - 216;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fstp ", stdout);
printf("%d", opcode_reg);
}
break;
case 208 :
case 209 :
case 210 :
case 211 :
case 212 :
case 213 :
case 214 :
case 215 :
opcode_reg = opcode2 - 208;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fst ", stdout);
printf("%d", opcode_reg);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fstp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fst ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fld ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 219 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fstp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fld ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fistp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fist ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fild ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 223 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 224 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fnstsw", stdout);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fistp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fild ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fild ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 218 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 233 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fucompp", stdout);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fisubr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fimul ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fidivr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fidiv ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 222 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 224 :
case 225 :
case 226 :
case 227 :
case 228 :
case 229 :
case 230 :
case 231 :
opcode_reg = opcode2 - 224;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fsubrp ", stdout);
printf("%d", opcode_reg);
}
break;
case 200 :
case 201 :
case 202 :
case 203 :
case 204 :
case 205 :
case 206 :
case 207 :
opcode_reg = opcode2 - 200;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fmulp ", stdout);
printf("%d", opcode_reg);
}
break;
case 240 :
case 241 :
case 242 :
case 243 :
case 244 :
case 245 :
case 246 :
case 247 :
opcode_reg = opcode2 - 240;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdivrp ", stdout);
printf("%d", opcode_reg);
}
break;
case 248 :
case 249 :
case 250 :
case 251 :
case 252 :
case 253 :
case 254 :
case 255 :
opcode_reg = opcode2 - 248;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdivp ", stdout);
printf("%d", opcode_reg);
}
break;
case 217 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fcompp", stdout);
}
break;
case 192 :
case 193 :
case 194 :
case 195 :
case 196 :
case 197 :
case 198 :
case 199 :
opcode_reg = opcode2 - 192;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("faddp ", stdout);
printf("%d", opcode_reg);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
default :
bt_assert(0);
}
}
break;
case 220 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 200 :
case 201 :
case 202 :
case 203 :
case 204 :
case 205 :
case 206 :
case 207 :
opcode_reg = opcode2 - 200;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fmul ", stdout);
printf("%d", opcode_reg);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fsub ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fmul ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdivr ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdiv ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fcomp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fcom ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fadd ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 216 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 224 :
case 225 :
case 226 :
case 227 :
case 228 :
case 229 :
case 230 :
case 231 :
opcode_reg = opcode2 - 224;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fsub ", stdout);
printf("%d", opcode_reg);
}
break;
case 200 :
case 201 :
case 202 :
case 203 :
case 204 :
case 205 :
case 206 :
case 207 :
opcode_reg = opcode2 - 200;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fmul ", stdout);
printf("%d", opcode_reg);
}
break;
case 240 :
case 241 :
case 242 :
case 243 :
case 244 :
case 245 :
case 246 :
case 247 :
opcode_reg = opcode2 - 240;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdiv ", stdout);
printf("%d", opcode_reg);
}
break;
case 216 :
case 217 :
case 218 :
case 219 :
case 220 :
case 221 :
case 222 :
case 223 :
opcode_reg = opcode2 - 216;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fcomp ", stdout);
printf("%d", opcode_reg);
}
break;
case 208 :
case 209 :
case 210 :
case 211 :
case 212 :
case 213 :
case 214 :
case 215 :
opcode_reg = opcode2 - 208;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fcom ", stdout);
printf("%d", opcode_reg);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fsub ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fdiv ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fadd ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 217 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 241 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fyl2x", stdout);
}
break;
case 200 :
case 201 :
case 202 :
case 203 :
case 204 :
case 205 :
case 206 :
case 207 :
opcode_reg = opcode2 - 200;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fxch ", stdout);
printf("%d", opcode_reg);
}
break;
case 253 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fscale", stdout);
}
break;
case 252 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("frndint", stdout);
}
break;
case 238 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fldz", stdout);
}
break;
case 232 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fld1", stdout);
}
break;
case 192 :
case 193 :
case 194 :
case 195 :
case 196 :
case 197 :
case 198 :
case 199 :
opcode_reg = opcode2 - 192;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fld ", stdout);
printf("%d", opcode_reg);
}
break;
case 224 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fchs", stdout);
}
break;
case 240 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("f2xm1", stdout);
}
break;
default :
bt_assert(opcode2 <= 0xbf);
switch (reg) {
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fstp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fst ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fstcw ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fldcw ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("fld ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 247 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("not ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("not ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("neg ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("neg ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("mul ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("idiv ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("div ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 246 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("test ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("not ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("neg ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("mul ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("idiv ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("div ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 72 :
case 73 :
case 74 :
case 75 :
case 76 :
case 77 :
case 78 :
case 79 :
opcode_reg = opcode - 72;
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("dec ", stdout);
i386_disassemble_r16(stdout, opcode_reg);
} else {
next_pc = pc = intp->pc;
fputs("dec ", stdout);
i386_disassemble_r32(stdout, opcode_reg);
}
break;
case 254 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("inc ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("dec ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 59 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 58 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 57 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 56 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 61 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 60 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 252 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("cld", stdout);
}
break;
case 153 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("cdq", stdout);
}
break;
case 152 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("cbw_cwde ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
fputs("al", stdout);
} else {
next_pc = pc = intp->pc;
fputs("cbw_cwde ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
fputs("ax", stdout);
}
break;
case 255 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("push ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("jmp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("inc ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("inc ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("dec ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("dec ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("call ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
bt_assert(0);
}
}
break;
case 232 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("call ", stdout);
printf("$0x%x", imm32);
}
break;
case 15 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
case 172 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shrd ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 173 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shrd ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 164 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("shld ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 165 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("shld ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 149 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setne ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 151 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setnbe ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 146 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setnae ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 158 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setle ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 156 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setl ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 159 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setg ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 148 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("sete ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 150 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("setbe ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 183 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("movzx ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 182 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("movzx ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("movzx ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 191 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("movsx ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 190 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("movsx ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("movsx ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 136 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("js ", stdout);
printf("$0x%x", imm32);
}
break;
case 138 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jp ", stdout);
printf("$0x%x", imm32);
}
break;
case 137 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jns ", stdout);
printf("$0x%x", imm32);
}
break;
case 139 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jnp ", stdout);
printf("$0x%x", imm32);
}
break;
case 133 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jne ", stdout);
printf("$0x%x", imm32);
}
break;
case 142 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jle ", stdout);
printf("$0x%x", imm32);
}
break;
case 140 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jl ", stdout);
printf("$0x%x", imm32);
}
break;
case 141 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jge ", stdout);
printf("$0x%x", imm32);
}
break;
case 143 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jg ", stdout);
printf("$0x%x", imm32);
}
break;
case 132 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("je ", stdout);
printf("$0x%x", imm32);
}
break;
case 134 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jbe ", stdout);
printf("$0x%x", imm32);
}
break;
case 130 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jb ", stdout);
printf("$0x%x", imm32);
}
break;
case 131 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("jae ", stdout);
printf("$0x%x", imm32);
}
break;
case 135 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("ja ", stdout);
printf("$0x%x", imm32);
}
break;
case 175 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("imul ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 171 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("bts ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 163 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("bt ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 189 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("bsr ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("bsr ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
default :
switch (reg) {
default :
bt_assert(0);
}
}
break;
case 35 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 34 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 33 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 32 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 37 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 36 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 3 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 2 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 1 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 0 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 5 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 4 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 19 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_r16(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
} else {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_r32(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 18 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_r8(stdout, reg);
fputs(",", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
}
break;
case 17 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r16(stdout, reg);
} else {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r32(stdout, reg);
}
break;
case 16 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
i386_disassemble_r8(stdout, reg);
}
break;
case 131 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xff00 | imm8 : imm8);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8 & 0x80 ? 0xffffff00 | imm8 : imm8);
}
break;
default :
bt_assert(0);
}
}
break;
case 129 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm16(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm32(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
default :
bt_assert(0);
}
}
break;
case 128 :
i386_decode_modrm(intp, &opcode2, &mod, &reg, &rm);
switch (opcode2) {
default :
switch (reg) {
case 6 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("xor ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 5 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sub ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 3 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("sbb ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 1 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("or ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 7 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("cmp ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 4 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("and ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 0 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("add ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
case 2 :
i386_decode_sib(intp, opcode2, &sib_scale, &sib_index, &sib_base, &disp8, &disp32);
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
i386_disassemble_rm8(stdout, mod, rm, sib_scale, sib_index, sib_base, disp8, disp32);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
default :
bt_assert(0);
}
}
break;
case 21 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
imm16 = i386_decode_imm16(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
fputs("ax", stdout);
fputs(",", stdout);
printf("$0x%x", imm16);
} else {
imm32 = i386_decode_imm32(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
fputs("eax", stdout);
fputs(",", stdout);
printf("$0x%x", imm32);
}
break;
case 20 :
if (prefix_flags & I386_PREFIX_OP_SIZE_OVERRIDE) {
bt_assert(0);
} else {
imm8 = i386_decode_imm8(intp);
next_pc = pc = intp->pc;
fputs("adc ", stdout);
fputs("al", stdout);
fputs(",", stdout);
printf("$0x%x", imm8);
}
break;
default:
bt_assert(0);
}
intp->pc = next_pc;
}
